<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxml="urn:schemas-microsoft-com:xslt"
	xmlns:gx="urn:shemas-artech-com:gx"
	exclude-result-prefixes="msxml gx"
	xmlns:gxca="urn:GXControlAdap">
  <xsl:output method="html"/>
  <xsl:template match="/" >
    <xsl:apply-templates select="/GxControl"/>
  </xsl:template>
  <xsl:template match="GxControl">
    <xsl:choose>
      <xsl:when test="@type = 'ColorSelector'">
        <xsl:call-template name="RenderColorSelector"/>
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <!-- Calculator design render -->
  <!-- ///////////////////  Implement your render here  ///////////////////-->
	<xsl:template name="RenderColorSelector">  
		<div atomicselection="true" >
			<table cellSpacing="2" cellPadding="1" >				
				<tbody>
					<tr>         
					<td>
						<img id="ColorSelector">
							<xsl:attribute name="src">
								<xsl:value-of select="gxca:GetMyPath()"/>
								<xsl:text>\img\colorselector</xsl:text><xsl:value-of select="gxca:GetStringPropertyValue('Type')"/>.png
							</xsl:attribute>
							<xsl:call-template name="setsize">
								<xsl:with-param name="size"><xsl:value-of select="gxca:GetStringPropertyValue('Size')"/></xsl:with-param>															
							</xsl:call-template>
						</img>         		
					</td>          	          		
					</tr>       
				</tbody>
			</table >
		</div>
	</xsl:template>

	<xsl:template name="setsize">
		<xsl:param name="size"/>
		
		<xsl:if test="$size = 'small'">
			<xsl:attribute name="style">						
				width:24px;height:24px;
			</xsl:attribute>
		</xsl:if>
		<xsl:if test="$size = 'big'">
			<xsl:attribute name="style">						
				width:48px;height:48px;
			</xsl:attribute>
		</xsl:if>
		<xsl:if test="$size = 'xl'">
			<xsl:attribute name="style">						
				width:60px;height:60px;
			</xsl:attribute>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>
