<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxml="urn:schemas-microsoft-com:xslt"
	xmlns:gx="urn:shemas-artech-com:gx"
	exclude-result-prefixes="msxml gx"
	xmlns:gxca="urn:GXControlAdap">
  <xsl:output method="html"/>
  <xsl:template match="/" >
    <xsl:apply-templates select="/GxControl"/>
  </xsl:template>
  <xsl:template match="GxControl">
    <xsl:choose>
      <xsl:when test="@type = 'RCOAdvancedHyperlink'">
        <xsl:call-template name="RenderRCOAdvancedHyperlink"/>
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <!-- RCOAdvancedHyperlink design render -->
  <!-- ///////////////////  Implement your render here  ///////////////////-->
  <xsl:template name="RenderRCOAdvancedHyperlink">
    	<table cellSpacing="0" cellPadding="0" background="">
      	<xsl:call-template name="AddTableStyleAttribute"/>
      	<tbody>
        	<tr>
          <td>              
              <a href="#">
		      <xsl:call-template name="AddRCOHyperLinkStyleAttribute"/>
			  WINDOW: <xsl:value-of select="gxca:GetPropValue('LinkDescription')"/> ( 
			  <xsl:value-of select="gxca:GetPropValue('LinkOpen')"/> )
              </a>
          </td>
        </tr>       
      </tbody>
    </table>
  </xsl:template>


  <!-- Helpers Templates -->

  <xsl:template name="AddTableStyleAttribute" >
    <xsl:variable name="Style">
      <xsl:text>width: 400px;</xsl:text>
      <xsl:text>height: 20px;</xsl:text>
      <xsl:text>border-style: solid;border-width: 2px;</xsl:text>
    </xsl:variable>
    <xsl:attribute name="style">
      <xsl:value-of select="$Style"/>
    </xsl:attribute>
  </xsl:template>
  
   <xsl:template name="AddRCOHyperLinkStyleAttribute" >
    <xsl:variable name="Style">
      <xsl:text>font-size: 14px; </xsl:text>
    </xsl:variable>
    <xsl:attribute name="style">
      <xsl:value-of select="$Style"/>
    </xsl:attribute>
  </xsl:template>
  
</xsl:stylesheet>
