<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxml="urn:schemas-microsoft-com:xslt"
	xmlns:gx="urn:shemas-artech-com:gx"
	exclude-result-prefixes="msxml gx"
	xmlns:gxca="urn:GXControlAdap">
  <xsl:output method="html"/>
  <xsl:template match="/" >
    <xsl:apply-templates select="/GxControl"/>
  </xsl:template>
  <xsl:template match="GxControl">
    <xsl:choose>
      <xsl:when test="@type = 'RCOLinkColor'">
        <xsl:call-template name="RenderRCOLinkColor"/>
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <!-- RCOLinkColor design render -->  
  <xsl:template name="RenderRCOLinkColor">
    	<table cellSpacing="0" cellPadding="0" background="">
      	<xsl:call-template name="AddTableStyleAttribute"/>
      	<tbody>
        	<tr>
          <td>              
              <a href="#">
		      <xsl:call-template name="AddRCOLinkColorStyleAttribute"/>
		      RCO Link Color
              </a>
          </td>
        </tr>       
      </tbody>
    </table>
  </xsl:template>


  <!-- Helpers Templates -->

  <xsl:template name="AddTableStyleAttribute" >
    <xsl:variable name="Style">
      <xsl:text>width: </xsl:text>
      <xsl:value-of select="gxca:GetPropertyValueInt('Width')"/>
      <xsl:text>; </xsl:text>
      <xsl:text>height: </xsl:text>
      <xsl:value-of select="gxca:GetPropertyValueInt('Height')"/>
      <xsl:text>; </xsl:text>
      <xsl:text>border-style: solid;border-width: 2px;</xsl:text>
    </xsl:variable>
    <xsl:attribute name="style">
      <xsl:value-of select="$Style"/>
    </xsl:attribute>
  </xsl:template>
  
   <xsl:template name="AddRCOLinkColorStyleAttribute" >
    <xsl:variable name="Style">
      <xsl:text>color: </xsl:text>
      <xsl:value-of select="gxca:GetPropValue('FontColorLink')"/>
      <xsl:text>; </xsl:text>	  
	  
      <xsl:text>font-size:</xsl:text>	  
      <xsl:value-of select="gxca:GetPropertyValueInt('FontSize')"/>
      <xsl:text>pt; </xsl:text>
	  
      <xsl:text>font-family:</xsl:text>
      <xsl:value-of select="gxca:GetPropValue('FontFamily')"/>
      <xsl:text>; </xsl:text>
	  
    </xsl:variable>
    <xsl:attribute name="style">
      <xsl:value-of select="$Style"/>
    </xsl:attribute>
  </xsl:template>
  
</xsl:stylesheet>
