<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxml="urn:schemas-microsoft-com:xslt"
	xmlns:gx="urn:shemas-artech-com:gx"
	exclude-result-prefixes="msxml gx"
	xmlns:gxca="urn:GXControlAdap">
  <xsl:output method="html"/>
  <xsl:template match="/" >
    <xsl:apply-templates select="/GxControl"/>
  </xsl:template>
  <xsl:template match="GxControl">
    <xsl:choose>
      <xsl:when test="@type = 'jqAccordion'">
        <xsl:call-template name="RenderjqAccordion"/>
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <!-- jqAccordion design render -->
  <!-- ///////////////////  Implement your render here  ///////////////////-->
  <xsl:template name="RenderjqAccordion">
    
	<table cellSpacing="0" cellPadding="0" border="0" align="left"> 
	<xsl:call-template name="AddTableStyle"/>
      
		<tr>
			<td style="white-space:nowrap;">
			<xsl:attribute name="containerId">PanelId</xsl:attribute>
			
			</td>
		</tr>
	</table>
    
  </xsl:template>


  <!-- Helpers Templates -->

  <xsl:template name="AddStyleAttribute" >
    <xsl:variable name="Style">
      <xsl:text>width: </xsl:text>
      <xsl:value-of select="gxca:GetPropertyValueInt('Width')"/>
      <xsl:text>; </xsl:text>
      <xsl:text>height: </xsl:text>
      <xsl:value-of select="gxca:GetPropertyValueInt('Height')"/>
      <xsl:text>; </xsl:text>
      <xsl:text>border-style: solid;	border-width: 2px;</xsl:text>
    </xsl:variable>
    <xsl:attribute name="style">
      <xsl:value-of select="$Style"/>
    </xsl:attribute>
  </xsl:template>

  <xsl:template name="AddTableStyle">
    <xsl:variable name="Style">
      <xsl:text>width: </xsl:text>
      <xsl:value-of select="gxca:GetPropertyValueInt('Width')"/>
      <xsl:text>; </xsl:text>
      <xsl:text>height: </xsl:text>
      <xsl:value-of select="gxca:GetPropertyValueInt('Height')"/>
      <xsl:text>; </xsl:text>
      <xsl:text>border-style: none;	border-width: 0px;</xsl:text>
      <xsl:text>background-repeat: no-repeat; background-color: Transparent;background-image: url(</xsl:text>
      <xsl:value-of select='gxca:GetMyPath()'/>
      <xsl:text>\images\</xsl:text>
      <xsl:value-of select="gxca:GetStringPropertyValue('Theme')"/>
      <xsl:text>.png);</xsl:text>
    </xsl:variable>
    <xsl:attribute name="style">
      <xsl:value-of select="$Style"/>
    </xsl:attribute>
  </xsl:template>

  <xsl:template name="AddThemeNameClassAtribute">
    <xsl:variable name="Class">
      <xsl:value-of select="gxca:GetStringPropertyValue('Theme')"/>
    </xsl:variable>
    <xsl:attribute name="class">
      <xsl:value-of select="$Class"/>
    </xsl:attribute>
  </xsl:template>

  <xsl:template name="AddCssPathHrefAttribute">
    <xsl:variable name="Href">
      <xsl:value-of select="gxca:GetMyPath()"/>
      <xsl:text>/css/</xsl:text>
      <xsl:value-of select="gxca:GetStringPropertyValue('Theme')"/>
      <xsl:text>/jquery-ui-1.8.16.custom.css</xsl:text>
    </xsl:variable>
    <xsl:attribute name="href">
      <xsl:value-of select="$Href"/>
    </xsl:attribute>
  </xsl:template>

</xsl:stylesheet>
