<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxml="urn:schemas-microsoft-com:xslt"
	xmlns:gx="urn:shemas-artech-com:gx"
	exclude-result-prefixes="msxml gx"
	xmlns:gxca="urn:GXControlAdap">
  <xsl:output method="html"/>
  <xsl:template match="/" >
    <xsl:apply-templates select="/GxControl"/>
  </xsl:template>
  <xsl:template match="GxControl">
    <xsl:choose>
      <xsl:when test="@type = 'jqSliderS'">
        <xsl:call-template name="RenderjqSliderS"/>
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <!-- jqSliderS design render -->
  <!-- ///////////////////  Implement your render here  ///////////////////-->
  <xsl:template name="RenderjqSliderS">
    <span atomicselection="true">
      <xsl:call-template name="AddStyleAttribute"/>
      
      <img>
	    <xsl:call-template name="AddStyleAttribute"/>
	  	<xsl:attribute name="src">
		  <xsl:value-of select="gxca:GetMyPath()"/>
		  <xsl:text>\images\jqslidersimple-</xsl:text>
		  <xsl:value-of select="gxca:GetStringPropertyValue('Orientation')"/>
		  <xsl:text>.png</xsl:text>
		</xsl:attribute>
	  </img>
   
      
      
      
    </span>


  </xsl:template>


  <!-- Helpers Templates -->

  <xsl:template name="AddStyleAttribute" >
    <xsl:variable name="Style">
      <xsl:variable name="orientation">
        <xsl:value-of select="gxca:GetStringPropertyValue('Orientation')"/>
      </xsl:variable>
	  <xsl:choose>
	    <xsl:when test="$orientation='horizontal'">
		  <xsl:text>width: </xsl:text>
		  <xsl:value-of select="gxca:GetPropertyValueInt('Width')"/>
		  <xsl:text>; </xsl:text>
		  <xsl:text>height: 21;</xsl:text>
		</xsl:when>
		<xsl:when test="$orientation='vertical'">
		  <xsl:text>width: 21;</xsl:text>
		  <xsl:text>height: </xsl:text>
		  <xsl:value-of select="gxca:GetPropertyValueInt('Height')"/>
		  <xsl:text>; </xsl:text>
		</xsl:when>
	  </xsl:choose>
      <xsl:text>border-style: solid;	border-width: 2px;</xsl:text>
    </xsl:variable>
    <xsl:attribute name="style">
      <xsl:value-of select="$Style"/>
    </xsl:attribute>
  </xsl:template>
</xsl:stylesheet>
