Ext.data.JsonP.gxui_Menu({"tagname":"class","name":"gxui.Menu","autodetected":{"aliases":true,"alternateClassNames":true,"extends":true,"mixins":true,"requires":true,"uses":true,"members":true,"code_type":true},"files":[{"filename":"MenuRender.js","href":"MenuRender.html#gxui-Menu"}],"aliases":{},"alternateClassNames":[],"extends":"gxui.UserControl","mixins":[],"requires":[],"uses":[],"members":[{"name":"ItemClickedId","tagname":"property","owner":"gxui.Menu","id":"property-ItemClickedId","meta":{}},{"name":"Menu","tagname":"property","owner":"gxui.Menu","id":"property-Menu","meta":{}},{"name":"methods","tagname":"property","owner":"gxui.Menu","id":"property-methods","meta":{"private":true}},{"name":"GetMenu","tagname":"method","owner":"gxui.Menu","id":"method-GetMenu","meta":{"private":true}},{"name":"SetMenu","tagname":"method","owner":"gxui.Menu","id":"method-SetMenu","meta":{"private":true}},{"name":"ShowMenu","tagname":"method","owner":"gxui.Menu","id":"method-ShowMenu","meta":{}},{"name":"ShowMenuXY","tagname":"method","owner":"gxui.Menu","id":"method-ShowMenuXY","meta":{}},{"name":"createMenu","tagname":"method","owner":"gxui.Menu","id":"method-createMenu","meta":{"private":true}},{"name":"getBasicItemConfig","tagname":"method","owner":"gxui.Menu","id":"method-getBasicItemConfig","meta":{"private":true}},{"name":"getContextMenuItems","tagname":"method","owner":"gxui.Menu","id":"method-getContextMenuItems","meta":{"private":true}},{"name":"getUnderlyingControl","tagname":"method","owner":"gxui.Menu","id":"method-getUnderlyingControl","meta":{"private":true}},{"name":"initialize","tagname":"method","owner":"gxui.Menu","id":"method-initialize","meta":{"private":true}},{"name":"itemClickHandler","tagname":"method","owner":"gxui.Menu","id":"method-itemClickHandler","meta":{"private":true}},{"name":"onRefresh","tagname":"method","owner":"gxui.Menu","id":"method-onRefresh","meta":{"private":true}},{"name":"onRender","tagname":"method","owner":"gxui.Menu","id":"method-onRender","meta":{"private":true}},{"name":"runDeferredMethod","tagname":"method","owner":"gxui.Menu","id":"method-runDeferredMethod","meta":{"private":true}},{"name":"ItemClick","tagname":"event","owner":"gxui.Menu","id":"event-ItemClick","meta":{}}],"code_type":"ext_define","id":"class-gxui.Menu","short_doc":"A basic floating menu control. ...","component":false,"superclasses":["gxui.UserControl"],"subclasses":[],"mixedInto":[],"parentMixins":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>gxui.UserControl<div class='subclass '><strong>gxui.Menu</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/MenuRender.html#gxui-Menu' target='_blank'>MenuRender.js</a></div></pre><div class='doc-contents'><p>A basic floating menu control. It supports adding buttons, separators and submenus. It's an implementation of Ext.menu.Menu.\nThe control basically loads a SDT which contains the menu items. Consequently you will have to\ndefine a variable based on a collection of gxuiToolbarItem SDT which must be assigned to the <a href=\"#!/api/gxui.Menu-property-Menu\" rel=\"gxui.Menu-property-Menu\" class=\"docClass\">Menu</a> property of the control.\nThis variable will have a collection of items (gxuiToolbarItem SDT) that will be displayed in the menu.</p>\n\n<p><p><img src=\"images/Menu/menu1.png\" alt=\"\" width=\"202\" height=\"105\"></p>\nExample of a data provider to load the items shown in the above image.</p>\n\n<pre><code>gxuiButton\n{\n    Id = !\"EXPORT\"\n    Text = !'Export to Excel'\n    Tooltip = 'Export to Excel'\n    Type = gxuiMenuItemTypes.Button\n}\ngxuiButton\n{\n    Id = !\"GENERATEPDF\"\n    Text = 'Generate PDF'\n    Tooltip = 'Generate PDF'\n    Type = gxuiMenuItemTypes.Button\n}\ngxuiButton\n{\n    Type = gxuiMenuItemTypes.Separator\n}\ngxuiButton\n{\n    Id = !\"INSERT\"\n    Text = 'Insert'\n    Tooltip = 'Insert'\n    Type = gxuiMenuItemTypes.Menu\n    Items\n    {\n        Item\n        {\n            Id = !'4'\n            Text = 'Insert Customer'\n            Tooltip = 'Insert Customer'\n            Type = gxuiMenuItemTypes.Button\n        }\n        Item\n        {\n            Id = !'5'\n            Text = 'Insert Company'\n            Tooltip = 'Insert Company'\n            Type = gxuiMenuItemTypes.Button\n        }\n    }\n}\n</code></pre>\n\n<p>To show the menu (for example when a TextBlock is clicked) use <a href=\"#!/api/gxui.Menu-method-ShowMenu\" rel=\"gxui.Menu-method-ShowMenu\" class=\"docClass\">ShowMenu</a> or ShowMenuXY methods.\n    Event TextBlock1.Click\n        gxui_Menu1.ShowMenu()\n    EndEvent</p>\n\n<p>gxuiMenu provides an ItemClick event that is fired when an item is selected.\n    Event gxui_Menu1.ItemClick\n      //Display selected menu option\n      msg(!'Item Clicked Id : ' + gxui_Menu1.ItemClickedId)\n    EndEvent</p>\n\n<p>gxuiMenu can also be associated to another gxui controls, like <a href=\"#!/api/gxui.GridExtension\" rel=\"gxui.GridExtension\" class=\"docClass\">gxui.GridExtension</a>.\nFor instance, if you want to display a context menu when the user right clicks on a selected line then you need to use this code.\n    Event Grid1.ContextMenu()\n        //Associate a context menu to the grid\n        gxui_Menu1.ShowMenu()\n    EndEvent</p>\n\n<p><p><img src=\"images/Menu/menu2.png\" alt=\"\" width=\"383\" height=\"200\"></p></p>\n\n<h1>More information:</h1>\n\n<p>For more examples please see the <a href=\"http://xev2.genexusserver.com/gxserver/action.aspx?1,RSSReader2.0:0:c9584656-94b6-4ccd-890f-332d11fc2c25:19\">online KB</a>.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-ItemClickedId' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/Properties.html#gxui-Menu-property-ItemClickedId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-property-ItemClickedId' class='name expandable'>ItemClickedId</a> : Text<span class=\"signature\"></span></div><div class='description'><div class='short'>The identifier of the menu option that was pressed. ...</div><div class='long'><p>The identifier of the menu option that was pressed. This property is useful when the <a href=\"#!/api/gxui.Menu-event-ItemClick\" rel=\"gxui.Menu-event-ItemClick\" class=\"docClass\">ItemClick</a> event is fired. (Runtime)</p>\n</div></div></div><div id='property-Menu' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/Properties.html#gxui-Menu-property-Menu' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-property-Menu' class='name expandable'>Menu</a> : gxuiToolbarItem<span class=\"signature\"></span></div><div class='description'><div class='short'>A variable based on a collection of gxuiToolbarItem SDT, with the menu definition. ...</div><div class='long'><p>A variable based on a collection of gxuiToolbarItem SDT, with the menu definition.</p>\n<ul><li><span class='pre'>Id</span> : String<div class='sub-desc'><p>An identifier for the item. When a menu option is pressed, the <a href=\"#!/api/gxui.Menu-property-ItemClickedId\" rel=\"gxui.Menu-property-ItemClickedId\" class=\"docClass\">ItemClickedId</a> property is set with the identifier set here, so you will know which menu option was pressed when the <a href=\"#!/api/gxui.Menu-event-ItemClick\" rel=\"gxui.Menu-event-ItemClick\" class=\"docClass\">ItemClick</a> event is fired.</p>\n</div></li><li><span class='pre'>Text</span> : String<div class='sub-desc'><p>The text of the menu option. Applies to Button, Menu and Text.</p>\n</div></li><li><span class='pre'>Tooltip</span> : String<div class='sub-desc'><p>A tooltip to show when the mouse hovers the item. Applies to Button and Menu.</p>\n</div></li><li><span class='pre'>Icon</span> : String<div class='sub-desc'><p>The path to an image to display in the item icon. Applies to Button and Menu.</p>\n</div></li><li><span class='pre'>IconCls</span> : String<div class='sub-desc'><p>A css class which sets a background image to be used as the icon for this menu option. Applies to Button and Menu.</p>\n</div></li><li><span class='pre'>Cls</span> : String<div class='sub-desc'><p>A CSS class to apply to the item's main element</p>\n</div></li><li><span class='pre'>Disabled</span> : Boolean<div class='sub-desc'><p>True to start disabled. Applies to Button, and Menu.</p>\n</div></li><li><span class='pre'>Type</span> : gxuiToolbarItemTypes<div class='sub-desc'><p>Defines the type of the item (defaults to Button). The supported types are:</p>\n\n<ul>\n<li>Button: A simple button. Customisations include aligned icons, tooltips and sizing options.</li>\n<li>Text: A text to be rendered inside the toolbar.</li>\n<li>Separator: Adds a vertical separator bar between toolbar items. It can't be a direct child of a Group item.</li>\n<li>Menu: A button that opens a menu. The menu options are set through the Items property. An arrow is automatically added to the button.</li>\n</ul>\n\n</div></li><li><span class='pre'>Hidden</span> : Boolean<div class='sub-desc'><p>True to start hidden.</p>\n</div></li><li><span class='pre'>Items</span> : gxuiToolbarItem[]<div class='sub-desc'><p>Collection of children items of the menu option. Applies to Menu only.</p>\n</div></li></ul></div></div></div><div id='property-methods' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-property-methods' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-property-methods' class='name expandable'>methods</a> : Object<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>\n</div><div class='long'>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-GetMenu' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-GetMenu' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-GetMenu' class='name expandable'>GetMenu</a>( <span class='pre'>data</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>Databindings ...</div><div class='long'><p>Databindings</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-SetMenu' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-SetMenu' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-SetMenu' class='name expandable'>SetMenu</a>( <span class='pre'>data</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>Databindings ...</div><div class='long'><p>Databindings</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-ShowMenu' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-ShowMenu' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-ShowMenu' class='name expandable'>ShowMenu</a>( <span class='pre'>[menu], [x], [y]</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Shows the menu. ...</div><div class='long'><p>Shows the menu. If the menu is called without parameters, the menu configured in the <a href=\"#!/api/gxui.Menu-property-Menu\" rel=\"gxui.Menu-property-Menu\" class=\"docClass\">Menu</a> property will be shown in the cursor position.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>menu</span> : gxuiToolbarItem[] (optional)<div class='sub-desc'><p>The menu to show. This parameter should be used when showing a menu different from the one specified in <a href=\"#!/api/gxui.Menu-property-Menu\" rel=\"gxui.Menu-property-Menu\" class=\"docClass\">Menu</a> property\nor when the menu specified in the <a href=\"#!/api/gxui.Menu-property-Menu\" rel=\"gxui.Menu-property-Menu\" class=\"docClass\">Menu</a> property is changed.</p>\n</div></li><li><span class='pre'>x</span> : Number (optional)<div class='sub-desc'><p>x position</p>\n</div></li><li><span class='pre'>y</span> : Number (optional)<div class='sub-desc'><p>y position</p>\n</div></li></ul></div></div></div><div id='method-ShowMenuXY' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-ShowMenuXY' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-ShowMenuXY' class='name expandable'>ShowMenuXY</a>( <span class='pre'>x, y</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Shows the menu configured in the Menu property in the specified position. ...</div><div class='long'><p>Shows the menu configured in the <a href=\"#!/api/gxui.Menu-property-Menu\" rel=\"gxui.Menu-property-Menu\" class=\"docClass\">Menu</a> property in the specified position.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>x</span> : Number<div class='sub-desc'><p>x position</p>\n</div></li><li><span class='pre'>y</span> : Number<div class='sub-desc'><p>y position</p>\n</div></li></ul></div></div></div><div id='method-createMenu' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-createMenu' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-createMenu' class='name expandable'>createMenu</a>( <span class='pre'>menu</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>menu</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-getBasicItemConfig' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-getBasicItemConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-getBasicItemConfig' class='name expandable'>getBasicItemConfig</a>( <span class='pre'>item</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>item</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-getContextMenuItems' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-getContextMenuItems' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-getContextMenuItems' class='name expandable'>getContextMenuItems</a>( <span class='pre'>contextMenu</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>contextMenu</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-getUnderlyingControl' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-getUnderlyingControl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-getUnderlyingControl' class='name expandable'>getUnderlyingControl</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-initialize' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-initialize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-initialize' class='name expandable'>initialize</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-itemClickHandler' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-itemClickHandler' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-itemClickHandler' class='name expandable'>itemClickHandler</a>( <span class='pre'>btn</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>btn</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-onRefresh' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-onRefresh' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-onRefresh' class='name expandable'>onRefresh</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-onRender' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-onRender' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-onRender' class='name expandable'>onRender</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-runDeferredMethod' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-method-runDeferredMethod' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-method-runDeferredMethod' class='name expandable'>runDeferredMethod</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>Overriden ...</div><div class='long'><p>Overriden</p>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-event'>Events</h3><div class='subsection'><div id='event-ItemClick' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Menu'>gxui.Menu</span><br/><a href='source/MenuRender.html#gxui-Menu-event-ItemClick' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Menu-event-ItemClick' class='name expandable'>ItemClick</a>( <span class='pre'>eOpts</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Fires after a menu option has been pressed. ...</div><div class='long'><p>Fires after a menu option has been pressed. The only options that fire this event are those of type Button.\nThe following properties are set when the event is fired:</p>\n\n<ul>\n<li><a href=\"#!/api/gxui.Menu-property-ItemClickedId\" rel=\"gxui.Menu-property-ItemClickedId\" class=\"docClass\">ItemClickedId</a></li>\n</ul>\n\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eOpts</span> : Object<div class='sub-desc'><p>The options object passed to Ext.util.Observable.addListener.</p>\n\n\n\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});