Ext.data.JsonP.gxui_Settings({"tagname":"class","name":"gxui.Settings","autodetected":{"aliases":true,"alternateClassNames":true,"extends":true,"mixins":true,"requires":true,"uses":true,"members":true,"code_type":true},"files":[{"filename":"SettingsRender.js","href":"SettingsRender.html#gxui-Settings"}],"aliases":{},"alternateClassNames":[],"extends":"gxui.UserControl","mixins":[],"requires":[],"uses":[],"members":[{"name":"Delay","tagname":"property","owner":"gxui.Settings","id":"property-Delay","meta":{}},{"name":"Enable","tagname":"property","owner":"gxui.Settings","id":"property-Enable","meta":{}},{"name":"InitialState","tagname":"property","owner":"gxui.Settings","id":"property-InitialState","meta":{}},{"name":"LOCALE_SCRIPT_ID","tagname":"property","owner":"gxui.Settings","id":"property-LOCALE_SCRIPT_ID","meta":{"private":true}},{"name":"Language","tagname":"property","owner":"gxui.Settings","id":"property-Language","meta":{}},{"name":"Provider","tagname":"property","owner":"gxui.Settings","id":"property-Provider","meta":{}},{"name":"RevertTablePaddingReset","tagname":"property","owner":"gxui.Settings","id":"property-RevertTablePaddingReset","meta":{}},{"name":"RevertTableSpacingReset","tagname":"property","owner":"gxui.Settings","id":"property-RevertTableSpacingReset","meta":{}},{"name":"SaveURL","tagname":"property","owner":"gxui.Settings","id":"property-SaveURL","meta":{}},{"name":"methods","tagname":"property","owner":"gxui.Settings","id":"property-methods","meta":{"private":true}},{"name":"GetState","tagname":"method","owner":"gxui.Settings","id":"method-GetState","meta":{"private":true}},{"name":"SetLanguage","tagname":"method","owner":"gxui.Settings","id":"method-SetLanguage","meta":{}},{"name":"SetState","tagname":"method","owner":"gxui.Settings","id":"method-SetState","meta":{"private":true}},{"name":"initialize","tagname":"method","owner":"gxui.Settings","id":"method-initialize","meta":{"private":true}},{"name":"onDestroy","tagname":"method","owner":"gxui.Settings","id":"method-onDestroy","meta":{"private":true}},{"name":"onRender","tagname":"method","owner":"gxui.Settings","id":"method-onRender","meta":{"private":true}}],"code_type":"ext_define","id":"class-gxui.Settings","short_doc":"The gxui.Settings control lets you set GxUI Library global settings. ...","component":false,"superclasses":["gxui.UserControl"],"subclasses":[],"mixedInto":[],"parentMixins":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>gxui.UserControl<div class='subclass '><strong>gxui.Settings</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/SettingsRender.html#gxui-Settings' target='_blank'>SettingsRender.js</a></div></pre><div class='doc-contents'><p>The <a href=\"#!/api/gxui.Settings\" rel=\"gxui.Settings\" class=\"docClass\">gxui.Settings</a> control lets you set GxUI Library global settings.\nIt does not show any control on the page and should be placed only once in the form, as the first GxUI control (for example, in the master page).</p>\n\n<p>For state management, it lets you select between storing the controls' state in cookies or in the server, through HTTP calls to a URL.\nThe default value is to store the state in cookies. This option is ok in development environments or simple applications, however, HTTP should be used in production environments\nwhere there is heavy usage of GxUI controls.</p>\n\n<p>For localization, you can choose the language of ExtJS standard texts (for example, those used in <a href=\"#!/api/gxui.GridExtension\" rel=\"gxui.GridExtension\" class=\"docClass\">gxui.GridExtension</a> column menu options.</p>\n\n<h1>Example</h1>\n\n<p>In the following example we will see how to store the state of a grid using <a href=\"#!/api/gxui.GridExtension\" rel=\"gxui.GridExtension\" class=\"docClass\">gxui.GridExtension</a> as its Custom Render in the server.</p>\n\n<p>Dragging <a href=\"#!/api/gxui.Settings\" rel=\"gxui.Settings\" class=\"docClass\">gxui.Settings</a> control to the Master Page of your KB automatically imports the relevant objects to work with this control.</p>\n\n<p>These objects are:</p>\n\n<ul>\n<li>gxuiSaveState (procedure)</li>\n<li>gxuiInitState (data provider)</li>\n<li>gxuiState (SDT)</li>\n</ul>\n\n\n<p>A code snippet will be also created in the Events of the Master Page.</p>\n\n<p>After we have the above mentioned objects in our KB, we will have to create the structures that will allow us to save the state of of the grid (or any gxui control).</p>\n\n<p>We start creating the UserState Transaction, which have the following structure:</p>\n\n<ul>\n<li>UserId *</li>\n<li>UserGXUIStateId *</li>\n<li>UserGXUIStateValue</li>\n</ul>\n\n\n<p>Once you have this transaction, we can modify the above mentioned objects as follows:</p>\n\n<h2>gxuiSaveState:</h2>\n\n<pre><code>Do 'Init'\nDo 'Save'\nDo 'Response'\n\nSub 'Init'\n    &amp;data = &amp;request.GetVariable(!'data')\n    &amp;matches = &amp;data.Matches(!'{\"name\":\"([^\"]*)\",\"value\":\"([^\"]*)\"}')\n    For &amp;match in &amp;matches\n        If &amp;match.Groups.Count = 2\n            &amp;state = new()\n            &amp;state.name = &amp;match.Groups.Item(1)\n            &amp;state.value = &amp;match.Groups.Item(2)\n            &amp;states.Add(&amp;state)            \n        EndIf\n    Endfor\nEndSub\n\nSub 'Save'\n    For &amp;state in &amp;states    \n        For each UserId UserGXUIStateId\n            Where UserId = &amp;user\n            Where UserGXUIStateId = &amp;state.name\n            If &amp;state.value = !'undefined'\n                Delete\n            Else\n                UserGXUIStateValue = &amp;state.value\n            Endif\n        When none\n            If &amp;state.value &lt;&gt; !'undefined'        \n                New\n                    UserId     = &amp;user\n                    UserGXUIStateId    = &amp;state.name\n                    UserGXUIStateValue    = &amp;state.value\n                EndNew\n            Endif    \n        Endfor                \n    Endfor\nEndSub\n\nSub 'Response'\n    &amp;response.AddHeader(!\"Content-Type\", !\"text/xml\")\n    &amp;response.AddString(!'{success: true}')\nEndSub\n</code></pre>\n\n<h2>gxuiInitState:</h2>\n\n<pre><code>gxuiStates\n{\n    gxuiState Where UserId = &amp;user\n    {\n        name = UserGXUIStateId.Trim()\n        value = UserGXUIStateValue.Trim()\n    }\n}\n</code></pre>\n\n<p>The SDT gxuiState remains the same (only has a name and a value).</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-Delay' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/Properties.html#gxui-Settings-property-Delay' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-property-Delay' class='name expandable'>Delay</a> : Integer<span class=\"signature\"></span></div><div class='description'><div class='short'>The milliseconds to delay the buffer changes. ...</div><div class='long'><p>The milliseconds to delay the buffer changes.</p>\n<p>Defaults to: <code>750</code></p></div></div></div><div id='property-Enable' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/Properties.html#gxui-Settings-property-Enable' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-property-Enable' class='name expandable'>Enable</a> : Combo<span class=\"signature\"></span></div><div class='description'><div class='short'>True to enable state management so the state of GxUI controles is remembered (gxui.GridExtension columns position and...</div><div class='long'><p>True to enable state management so the state of GxUI controles is remembered (<a href=\"#!/api/gxui.GridExtension\" rel=\"gxui.GridExtension\" class=\"docClass\">gxui.GridExtension</a> columns position and width, <a href=\"#!/api/gxui.Layout\" rel=\"gxui.Layout\" class=\"docClass\">gxui.Layout</a> regions collapsing and dimensions, <a href=\"#!/api/gxui.Treeview\" rel=\"gxui.Treeview\" class=\"docClass\">gxui.Treeview</a> nodes collapsing, etc).\nPossible values:</p>\n\n<ul>\n<li>True</li>\n<li>False</li>\n</ul>\n\n<p>Defaults to: <code>True</code></p></div></div></div><div id='property-InitialState' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/Properties.html#gxui-Settings-property-InitialState' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-property-InitialState' class='name expandable'>InitialState</a> : gxuiState<span class=\"signature\"></span></div><div class='description'><div class='short'>The variable where the initial state is stored. ...</div><div class='long'><p>The variable where the initial state is stored. State is stored as a key/value pair.</p>\n</div></div></div><div id='property-LOCALE_SCRIPT_ID' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/SettingsRender.html#gxui-Settings-property-LOCALE_SCRIPT_ID' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-property-LOCALE_SCRIPT_ID' class='name expandable'>LOCALE_SCRIPT_ID</a> : String<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<p>Defaults to: <code>&quot;ext-lang&quot;</code></p></div></div></div><div id='property-Language' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/Properties.html#gxui-Settings-property-Language' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-property-Language' class='name expandable'>Language</a> : Combo<span class=\"signature\"></span></div><div class='description'><div class='short'>Language for ExtJS standard texts (for example, grid's column menu options). ...</div><div class='long'><p>Language for ExtJS standard texts (for example, <a href=\"#!/api/gxui.GridExtension\" rel=\"gxui.GridExtension\" class=\"docClass\">grid's</a> column menu options). This property should be used for setting the language on page load. For changing the language in a user event use <a href=\"#!/api/gxui.Settings-method-SetLanguage\" rel=\"gxui.Settings-method-SetLanguage\" class=\"docClass\">SetLanguage</a> method instead.\nPossible values:</p>\n\n<ul>\n<li>Afrikaans</li>\n<li>Bulgarian</li>\n<li>Catalan / Valencian</li>\n<li>Czech</li>\n<li>Danish</li>\n<li>German</li>\n<li>Modern Greek</li>\n<li>English</li>\n<li>British English</li>\n<li>Spanish / Castilian</li>\n<li>Persian Arab</li>\n<li>Finnish</li>\n<li>French</li>\n<li>French Canada</li>\n<li>Hebrew</li>\n<li>Croatian</li>\n<li>Hungarian</li>\n<li>Indonesian</li>\n<li>Italian</li>\n<li>Japanese</li>\n<li>Korean</li>\n<li>Lithuanian</li>\n<li>Latvian</li>\n<li>Macedonia</li>\n<li>Dutch</li>\n<li>Norwegian (NB)</li>\n<li>Norwegian (NN)</li>\n<li>Polish</li>\n<li>Portuguese</li>\n<li>Portuguese Brazil</li>\n<li>Portuguese Portugal</li>\n<li>Romanian</li>\n<li>Russian</li>\n<li>Slovak</li>\n<li>Slovenian</li>\n<li>Serbian</li>\n<li>Serbian Cyrillic</li>\n<li>Swedish</li>\n<li>Thailand</li>\n<li>Turkish</li>\n<li>Ukrainian</li>\n<li>Vietnamese</li>\n<li>Simplified Chinese</li>\n<li>Traditional Chinese</li>\n</ul>\n\n<p>Defaults to: <code>English</code></p></div></div></div><div id='property-Provider' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/Properties.html#gxui-Settings-property-Provider' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-property-Provider' class='name expandable'>Provider</a> : Combo<span class=\"signature\"></span></div><div class='description'><div class='short'>State management provider. ...</div><div class='long'><p>State management provider. If Cookie is selected, the state is stored in cookies. If HTTP is selected, state is stored in a remote server, through HTTP calls to the URL configured in <a href=\"#!/api/gxui.Settings-property-SaveURL\" rel=\"gxui.Settings-property-SaveURL\" class=\"docClass\">SaveURL</a> property. Cookie is not recommended for production environments, with many controls.\nPossible values:</p>\n\n<ul>\n<li>Cookie</li>\n<li>HTTP</li>\n</ul>\n\n<p>Defaults to: <code>Cookie</code></p></div></div></div><div id='property-RevertTablePaddingReset' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/Properties.html#gxui-Settings-property-RevertTablePaddingReset' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-property-RevertTablePaddingReset' class='name expandable'>RevertTablePaddingReset</a> : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>True to revert ExtJS CSS reset of TH and TD elements padding. ...</div><div class='long'><p>True to revert ExtJS CSS reset of TH and TD elements padding.</p>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='property-RevertTableSpacingReset' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/Properties.html#gxui-Settings-property-RevertTableSpacingReset' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-property-RevertTableSpacingReset' class='name expandable'>RevertTableSpacingReset</a> : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>True to revert ExtJS CSS reset of TABLE elements border-spacing and border-collapse properties. ...</div><div class='long'><p>True to revert ExtJS CSS reset of TABLE elements border-spacing and border-collapse properties.</p>\n<p>Defaults to: <code>true</code></p></div></div></div><div id='property-SaveURL' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/Properties.html#gxui-Settings-property-SaveURL' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-property-SaveURL' class='name expandable'>SaveURL</a> : Text<span class=\"signature\"></span></div><div class='description'><div class='short'><p>The URL of the web service where the state changes will be notified.</p>\n</div><div class='long'><p>The URL of the web service where the state changes will be notified.</p>\n</div></div></div><div id='property-methods' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/SettingsRender.html#gxui-Settings-property-methods' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-property-methods' class='name expandable'>methods</a> : Object<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>\n</div><div class='long'>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-GetState' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/SettingsRender.html#gxui-Settings-method-GetState' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-method-GetState' class='name expandable'>GetState</a>( <span class='pre'>data</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>Databinding ...</div><div class='long'><p>Databinding</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-SetLanguage' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/SettingsRender.html#gxui-Settings-method-SetLanguage' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-method-SetLanguage' class='name expandable'>SetLanguage</a>( <span class='pre'>lang, [charset]</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Sets the language for ExtJS standard texts ...</div><div class='long'><p>Sets the language for ExtJS standard texts</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>lang</span> : String<div class='sub-desc'><p>Language to set</p>\n</div></li><li><span class='pre'>charset</span> : String (optional)<div class='sub-desc'><p>Charset for the script tag to use for including the localized standard texts</p>\n</div></li></ul></div></div></div><div id='method-SetState' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/SettingsRender.html#gxui-Settings-method-SetState' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-method-SetState' class='name expandable'>SetState</a>( <span class='pre'>data</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>Databinding ...</div><div class='long'><p>Databinding</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-initialize' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/SettingsRender.html#gxui-Settings-method-initialize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-method-initialize' class='name expandable'>initialize</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-onDestroy' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/SettingsRender.html#gxui-Settings-method-onDestroy' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-method-onDestroy' class='name expandable'>onDestroy</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-onRender' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Settings'>gxui.Settings</span><br/><a href='source/SettingsRender.html#gxui-Settings-method-onRender' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Settings-method-onRender' class='name expandable'>onRender</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div></div></div></div></div>","meta":{}});