Ext.data.JsonP.gxui_Toolbar({"tagname":"class","name":"gxui.Toolbar","autodetected":{"aliases":true,"alternateClassNames":true,"extends":true,"mixins":true,"requires":true,"uses":true,"members":true,"code_type":true},"files":[{"filename":"ToolbarRender.js","href":"ToolbarRender.html#gxui-Toolbar"}],"aliases":{},"alternateClassNames":[],"extends":"gxui.UserControl","mixins":[],"requires":[],"uses":[],"members":[{"name":"ButtonPressedId","tagname":"property","owner":"gxui.Toolbar","id":"property-ButtonPressedId","meta":{}},{"name":"Data","tagname":"property","owner":"gxui.Toolbar","id":"property-Data","meta":{}},{"name":"EditFieldValue","tagname":"property","owner":"gxui.Toolbar","id":"property-EditFieldValue","meta":{}},{"name":"Height","tagname":"property","owner":"gxui.Toolbar","id":"property-Height","meta":{}},{"name":"Width","tagname":"property","owner":"gxui.Toolbar","id":"property-Width","meta":{}},{"name":"methods","tagname":"property","owner":"gxui.Toolbar","id":"property-methods","meta":{"private":true}},{"name":"ChangeToolbar","tagname":"method","owner":"gxui.Toolbar","id":"method-ChangeToolbar","meta":{}},{"name":"DisableItem","tagname":"method","owner":"gxui.Toolbar","id":"method-DisableItem","meta":{}},{"name":"EnableItem","tagname":"method","owner":"gxui.Toolbar","id":"method-EnableItem","meta":{}},{"name":"GetData","tagname":"method","owner":"gxui.Toolbar","id":"method-GetData","meta":{"private":true}},{"name":"GetToolbar","tagname":"method","owner":"gxui.Toolbar","id":"method-GetToolbar","meta":{"private":true}},{"name":"HideItem","tagname":"method","owner":"gxui.Toolbar","id":"method-HideItem","meta":{}},{"name":"SetData","tagname":"method","owner":"gxui.Toolbar","id":"method-SetData","meta":{"private":true}},{"name":"ShowItem","tagname":"method","owner":"gxui.Toolbar","id":"method-ShowItem","meta":{}},{"name":"adjustWidth","tagname":"method","owner":"gxui.Toolbar","id":"method-adjustWidth","meta":{"private":true}},{"name":"buttonActionHandler","tagname":"method","owner":"gxui.Toolbar","id":"method-buttonActionHandler","meta":{"private":true}},{"name":"buttonClickHandler","tagname":"method","owner":"gxui.Toolbar","id":"method-buttonClickHandler","meta":{"private":true}},{"name":"changeItemPropertyValue","tagname":"method","owner":"gxui.Toolbar","id":"method-changeItemPropertyValue","meta":{"private":true}},{"name":"createButtons","tagname":"method","owner":"gxui.Toolbar","id":"method-createButtons","meta":{"private":true}},{"name":"createToolbar","tagname":"method","owner":"gxui.Toolbar","id":"method-createToolbar","meta":{"private":true}},{"name":"defineBtnsDropTarget","tagname":"method","owner":"gxui.Toolbar","id":"method-defineBtnsDropTarget","meta":{"private":true}},{"name":"editActionHandler","tagname":"method","owner":"gxui.Toolbar","id":"method-editActionHandler","meta":{"private":true}},{"name":"findItem","tagname":"method","owner":"gxui.Toolbar","id":"method-findItem","meta":{"private":true}},{"name":"getBtnCls","tagname":"method","owner":"gxui.Toolbar","id":"method-getBtnCls","meta":{"private":true}},{"name":"getConfig","tagname":"method","owner":"gxui.Toolbar","id":"method-getConfig","meta":{"private":true}},{"name":"getUnderlyingControl","tagname":"method","owner":"gxui.Toolbar","id":"method-getUnderlyingControl","meta":{"private":true}},{"name":"getUniqueButtonId","tagname":"method","owner":"gxui.Toolbar","id":"method-getUniqueButtonId","meta":{"private":true}},{"name":"initialize","tagname":"method","owner":"gxui.Toolbar","id":"method-initialize","meta":{"private":true}},{"name":"onRefresh","tagname":"method","owner":"gxui.Toolbar","id":"method-onRefresh","meta":{"private":true}},{"name":"onRender","tagname":"method","owner":"gxui.Toolbar","id":"method-onRender","meta":{"private":true}},{"name":"refreshButtons","tagname":"method","owner":"gxui.Toolbar","id":"method-refreshButtons","meta":{"private":true}},{"name":"ButtonPressed","tagname":"event","owner":"gxui.Toolbar","id":"event-ButtonPressed","meta":{}}],"code_type":"ext_define","id":"class-gxui.Toolbar","short_doc":"Toolbar User Control. ...","component":false,"superclasses":["gxui.UserControl"],"subclasses":[],"mixedInto":[],"parentMixins":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'>gxui.UserControl<div class='subclass '><strong>gxui.Toolbar</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/ToolbarRender.html#gxui-Toolbar' target='_blank'>ToolbarRender.js</a></div></pre><div class='doc-contents'><p>Toolbar User Control. Wraps Ext.toolbar.Toolbar so it can be used from GeneXus.\nThe control basically loads a SDT which contains the toolbar items. Consequently you will have to\ndefine a variable based on gxuiToolbar SDT which must be assigned to the <a href=\"#!/api/gxui.Toolbar-property-Data\" rel=\"gxui.Toolbar-property-Data\" class=\"docClass\">Data</a> property of the control.\nThis variable will have a collection of items (gxuiToolbarItem SDT) that will be displayed in the toolbar.</p>\n\n<h1>Basic Toolbar</h1>\n\n<p><p><img src=\"images/Toolbar/gxuiToolbar.png\" alt=\"Toolbar sample\" width=\"383\" height=\"32\"></p>\nThe code below is an example of a Data Provider that produces a simple toolbar as the one shown in the image.</p>\n\n<pre><code>   gxuiToolbar\n   {\n       Buttons\n       {\n           Item\n           {\n               Id = !\"DSP\"\n               Text = \"Display\"\n               Tooltip = \"Tooltip for Display Button\"\n               Type = gxuiToolbarItemTypes.Button\n               Icon = ActionDisplay.Link()\n           }\n           Item\n           {\n               Id = !\"UPD\"\n               Text = \"Update\"\n               Tooltip = \"Toltip for Update Button\"\n               Type = gxuiToolbarItemTypes.Button\n               Icon = ActionUpdate.Link()\n           }\n           Item\n           {\n               Id = !\"DLT\"\n               Text = \"Delete\"\n               Tooltip = \"Tooltip for Delete Button\"\n               Type = gxuiToolbarItemTypes.Button\n               Icon = ActionDelete.Link()\n               AskConfirmation = True\n               Confirmation\n               {\n                   Message = !\"Please confirm this action.\"\n                   CancelButtonText = !\"Cancel\"\n                   OKButtonText = !\"Delete\"\n               }\n           }\n           Item\n           {\n               Id = !\"SEARCH\"\n               Text = \"Search...\"\n               Tooltip = \"Enter search query.\"\n               Type = gxuiToolbarItemTypes.Edit\n           }\n       }\n   }\n</code></pre>\n\n<h1>Multi-level menu</h1>\n\n<p><p><img src=\"images/Toolbar/gxuiToolbar2.png\" alt=\"Toolbar sample\" width=\"470\" height=\"114\"></p></p>\n\n<p>Example of a data provider to load the items shown in the above image.</p>\n\n<pre><code>   gxuiToolbar\n   {\n       Buttons\n       {\n           Item\n           {\n               Id = !\"DSP\"\n               Text = \"Display\"\n               Tooltip = \"Tooltip for Display Button\"\n               Type = gxuiToolbarItemTypes.Menu\n               Icon = ActionDisplay.Link()\n               Items\n               {\n                   Item\n                   {\n                       Id = !\"DSP11\"\n                       Text = \"Display incoming calls\"\n                       Tooltip = \"Tooltip for display incoming calls button\"\n                       Type = gxuiToolbarItemTypes.Button\n                       Icon = ActionDisplay.Link()\n                   }\n                   Item\n                   {\n                       Id = !\"DSP12\"\n                       Text = \"Display outgoing calls\"\n                       Tooltip = \"Tooltip for display outgoing calls button\"\n                       Type = gxuiToolbarItemTypes.Menu\n                       Icon = ActionDisplay.Link()\n                       Items\n                       {\n                           Item\n                           {\n                               Id = !\"DSP121\"\n                               Text = \"Display outgoing calls - Today\"\n                               Tooltip = \"Tooltip for display outgoing calls Today button\"\n                               Type = gxuiToolbarItemTypes.Button\n                               Icon = ActionDisplay.Link()\n                           }\n                           Item\n                           {\n                               Id = !\"DSP122\"\n                               Text = \"Display outgoing calls - Yesterday\"\n                               Tooltip = \"Tooltip for display outgoing calls Yesterday button\"\n                               Type = gxuiToolbarItemTypes.Button\n                               Icon = ActionDisplay.Link()\n                           }\n                       }\n                   }\n               }\n           }\n           Item\n           {\n               Id = !\"UPD\"\n               Text = \"Update\"\n               Tooltip = \"Toltip for Update Button\"\n               Type = gxuiToolbarItemTypes.Button\n               Icon = ActionUpdate.Link()\n           }\n           Item\n           {\n               Id = !\"DLT\"\n               Text = \"Delete\"\n               Tooltip = \"Tooltip for Delete Button\"\n               Type = gxuiToolbarItemTypes.Button\n               Icon = ActionDelete.Link()\n               AskConfirmation = True\n               Confirmation\n               {\n                   Message = !\"Please confirm this action.\"\n                   CancelButtonText = !\"Cancel\"\n                   OKButtonText = !\"Delete\"\n               }\n           }\n           Item\n           {\n               Id = !\"SEARCH\"\n               Text = \"Search...\"\n               Tooltip = \"Enter search query.\"\n               Type = gxuiToolbarItemTypes.Edit\n           }\n       }\n   }\n</code></pre>\n\n<h1>More information:</h1>\n\n<p>For more examples please see the <a href=\"http://xev2.genexusserver.com/gxserver/action.aspx?1,RSSReader2.0:0:c9584656-94b6-4ccd-890f-332d11fc2c25:15\">online KB</a>.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-ButtonPressedId' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/Properties.html#gxui-Toolbar-property-ButtonPressedId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-property-ButtonPressedId' class='name expandable'>ButtonPressedId</a> : Text<span class=\"signature\"></span></div><div class='description'><div class='short'>The identifier of the button that was pressed. ...</div><div class='long'><p>The identifier of the button that was pressed. This property is useful when the <a href=\"#!/api/gxui.Toolbar-event-ButtonPressed\" rel=\"gxui.Toolbar-event-ButtonPressed\" class=\"docClass\">ButtonPressed</a> event is fired. (Runtime)</p>\n</div></div></div><div id='property-Data' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/Properties.html#gxui-Toolbar-property-Data' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-property-Data' class='name expandable'>Data</a> : gxuiToolbar<span class=\"signature\"></span></div><div class='description'><div class='short'>A variable based on gxuiToolbar SDT, with the toolbar definition. ...</div><div class='long'><p>A variable based on gxuiToolbar SDT, with the toolbar definition.</p>\n<ul><li><span class='pre'>Buttons</span> : gxuiToolbarItem[]<div class='sub-desc'><p>A collection containing the list of toolbar items to render.</p>\n<ul><li><span class='pre'>Id</span> : String<div class='sub-desc'><p>An identifier for the item. When a button is pressed, the <a href=\"#!/api/gxui.Toolbar-property-ButtonPressedId\" rel=\"gxui.Toolbar-property-ButtonPressedId\" class=\"docClass\">ButtonPressedId</a> property is set with the identifier set here, so you will know which button was pressed when the <a href=\"#!/api/gxui.Toolbar-event-ButtonPressed\" rel=\"gxui.Toolbar-event-ButtonPressed\" class=\"docClass\">ButtonPressed</a> event is fired.</p>\n</div></li><li><span class='pre'>Text</span> : String<div class='sub-desc'><p>The text of the toolbar item. Applies to Button, Menu, SplitButton, Group, Edit (shown as placeholder) and Text.</p>\n</div></li><li><span class='pre'>Tooltip</span> : String<div class='sub-desc'><p>A tooltip to show when the mouse hovers the item. Applies to Button, Menu and SplitButton.</p>\n</div></li><li><span class='pre'>Icon</span> : String<div class='sub-desc'><p>The path to an image to display in the item icon. Applies to Button, Menu and SplitButton.</p>\n</div></li><li><span class='pre'>IconCls</span> : String<div class='sub-desc'><p>A css class which sets a background image to be used as the icon for this toolbar item. Applies to Button, Menu and SplitButton.</p>\n</div></li><li><span class='pre'>IconAlign</span> : gxuiToolbarItemIconAlign<div class='sub-desc'><p>The side of the Button box to render the icon. Four values are allowed:</p>\n\n<ul>\n<li>Top</li>\n<li>Right</li>\n<li>Bottom</li>\n<li>Left</li>\n</ul>\n\n\n<p>Applies to Button, Menu and SplitButton.</p>\n</div></li><li><span class='pre'>Cls</span> : String<div class='sub-desc'><p>A CSS class to apply to the item's main element</p>\n</div></li><li><span class='pre'>EnableToggle</span> : Boolean<div class='sub-desc'><p>True to enable pressed/not pressed toggling. Applies to Button and SplitButton.</p>\n</div></li><li><span class='pre'>Pressed</span> : Boolean<div class='sub-desc'><p>True to start pressed (only if EnableToggle = true). Applies to Button and SplitButton.</p>\n</div></li><li><span class='pre'>Disabled</span> : Boolean<div class='sub-desc'><p>True to start disabled. Applies to Button, Edit, Menu and SplitButton.</p>\n</div></li><li><span class='pre'>Type</span> : gxuiToolbarItemTypes<div class='sub-desc'><p>Defines the type of the item (defaults to Button). The available types are:</p>\n\n<ul>\n<li>Button: A simple button. Customisations include aligned icons, tooltips and sizing options.</li>\n<li>Text: A text to be rendered inside the toolbar.</li>\n<li>Edit: An edit field. Its value can be retrieved through the <a href=\"#!/api/gxui.Toolbar-property-EditFieldValue\" rel=\"gxui.Toolbar-property-EditFieldValue\" class=\"docClass\">EditFieldValue</a> property.</li>\n<li>ComboBox: A combo box. The items inside the combo box are set through the Items property, by setting the Id and Text properties of each child item. Its value can be retrieved through the <a href=\"#!/api/gxui.Toolbar-property-EditFieldValue\" rel=\"gxui.Toolbar-property-EditFieldValue\" class=\"docClass\">EditFieldValue</a> property.</li>\n<li>Fill: A non-rendering placeholder item. When used, all items at its right side are right aligned.</li>\n<li>Separator: Adds a vertical separator bar between toolbar items. It can't be a direct child of a Group item.</li>\n<li>Menu: A button that opens a menu. The menu options are set through the Items property. An arrow is automatically added to the button.\nYou can change the alignment of the arrow using the ArrowAlign property.</li>\n<li>SplitButton: A split button that provides a built-in dropdown arrow used to display a dropdown menu that provides additional options to the primary button action.</li>\n<li><p>Group: A container for arranging a group of related Buttons in a tabular manner. The items inside the group are set through the Items property.\nBy setting RowSpan and ColSpan properties in child items, complex layouts can be accomplished within the table.\nThe basic concept of building a layout inside the group is conceptually very similar to building up a standard HTML table.\nYou simply add each item that you want to include along with any span attributes specified as the special config properties of RowSpan and ColSpan\nwhich work exactly like their HTML counterparts. Rather than explicitly creating and nesting rows and columns as you would in HTML,\nyou simply specify the total column count in the GroupColumns property and start adding items in their natural order from left to right, top to bottom.\nThe layout will automatically figure out, based on the column count, rowspans and colspans, how to position each item within the table.\nJust like with HTML tables, your rowspans and colspans must add up correctly in your overall layout or you'll end up with missing and/or extra items.\nExample usage:</p>\n\n<pre><code>  gxuiToolbar\n  {\n      Buttons\n      {\n          Item\n          {\n              Text = 'File'\n              Type = gxuiToolbarItemTypes.Group\n              GroupColumns = 3\n              Items\n              {\n                  Item\n                  {\n                      Id = !'New'\n                      Text = 'New'\n                      Type = gxuiToolbarItemTypes.Button\n                      Scale = gxuiToolbarItemScale.Large\n                      RowSpan = 3\n                  }\n                  Item\n                  {\n                      Id = !'Open'\n                      Text = 'Open'\n                      Type = gxuiToolbarItemTypes.Button\n                      Scale = gxuiToolbarItemScale.Large\n                      RowSpan = 3\n                  }\n                  Item\n                  {\n                      Id = !'Close'\n                      Text = 'Close'\n                      Type = gxuiToolbarItemTypes.Button\n                  }\n                  Item\n                  {\n                      Id = !'CloseKB'\n                      Text = 'Close KB'\n                      Type = gxuiToolbarItemTypes.Button\n                  }\n                  {\n                      Id = !'Exit'\n                      Text = 'Exit'\n                      Type = gxuiToolbarItemTypes.Button\n                  }\n              }\n          }\n      }\n  }\n</code></pre></li>\n</ul>\n\n</div></li><li><span class='pre'>Hidden</span> : Boolean<div class='sub-desc'><p>True to start hidden.</p>\n</div></li><li><span class='pre'>GroupColumns</span> : Number<div class='sub-desc'><p>Groups show toolbar items in a tabular manner. The total number of columns to create in the table is set through this property. If not specified it will be rendered into a single row using one column per item. Applies only to Group.</p>\n</div></li><li><span class='pre'>Scale</span> : gxuiToolbarItemScale<div class='sub-desc'><p>The size of the Button. Three values are allowed:</p>\n\n<ul>\n<li>Small - Results in the button element being 16px high.</li>\n<li>Medium - Results in the button element being 24px high.</li>\n<li>Large - Results in the button element being 32px high.</li>\n</ul>\n\n\n<p>Applies to Button, Menu and SplitButton.</p>\n</div></li><li><span class='pre'>ArrowAlign</span> : gxuiToolbarItemArrowAlign<div class='sub-desc'><p>The side of the button box to render the arrow if the button has an associated menu. Two values are allowed:</p>\n\n<ul>\n<li>Right</li>\n<li>Bottom</li>\n</ul>\n\n\n<p>Applies to Menu and SplitButton.</p>\n</div></li><li><span class='pre'>RowSpan</span> : Number<div class='sub-desc'><p>Number of rows the item will span. Only applies to items that are direct children of a Group item.\nSee the documentation about the Group item type for detailed information.</p>\n</div></li><li><span class='pre'>ColSpan</span> : Number<div class='sub-desc'><p>Number of columns the item will span. Only applies to items that are direct children of a Group item.\nSee the documentation about the Group item type for detailed information.</p>\n</div></li><li><span class='pre'>Value</span> : String<div class='sub-desc'><p>Initial value for Edit items.</p>\n</div></li><li><span class='pre'>Width</span> : String<div class='sub-desc'><p>Item width in pixels.</p>\n</div></li><li><span class='pre'>AskConfirmation</span> : Boolean<div class='sub-desc'><p>Indicates if the user should be prompted for confirmation when a button is pressed, before executing the <a href=\"#!/api/gxui.Toolbar-event-ButtonPressed\" rel=\"gxui.Toolbar-event-ButtonPressed\" class=\"docClass\">ButtonPressed</a> event. If the user confirms, the event is executed.</p>\n</div></li><li><span class='pre'>Confirmation</span> : gxuiToolbarItem.Confirmation<div class='sub-desc'><p>Configuration properties for the confirmation dialog.</p>\n<ul><li><span class='pre'>OKButtonText</span> : String<div class='sub-desc'><p>Text for the OK button (defaults to 'OK')</p>\n</div></li><li><span class='pre'>CancelButtonText</span> : String<div class='sub-desc'><p>Text for the Cancel button (defaults to 'Cancel').</p>\n</div></li><li><span class='pre'>Message</span> : String<div class='sub-desc'><p>(required) Text for the dialog message.</p>\n</div></li><li><span class='pre'>Title</span> : String<div class='sub-desc'><p>Text for the dialog title.</p>\n</div></li></ul></div></li><li><span class='pre'>Items</span> : gxuiToolbarItem[]<div class='sub-desc'><p>Collection of children items of the button. Applies to Menu, SplitButton and Group.</p>\n</div></li></ul></div></li></ul></div></div></div><div id='property-EditFieldValue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/Properties.html#gxui-Toolbar-property-EditFieldValue' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-property-EditFieldValue' class='name expandable'>EditFieldValue</a> : Text<span class=\"signature\"></span></div><div class='description'><div class='short'>The value of the edit field that was lost focus or where the Enter key was pressed. ...</div><div class='long'><p>The value of the edit field that was lost focus or where the Enter key was pressed. (Runtime)</p>\n</div></div></div><div id='property-Height' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/Properties.html#gxui-Toolbar-property-Height' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-property-Height' class='name expandable'>Height</a> : Text<span class=\"signature\"></span></div><div class='description'><div class='short'>Control height in pixels. ...</div><div class='long'><p>Control height in pixels. If auto is specified, the height is the sum of the height of the items.</p>\n<p>Defaults to: <code>auto</code></p></div></div></div><div id='property-Width' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/Properties.html#gxui-Toolbar-property-Width' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-property-Width' class='name expandable'>Width</a> : Text<span class=\"signature\"></span></div><div class='description'><div class='short'>Control width in pixels. ...</div><div class='long'><p>Control width in pixels. If auto is specified, the width is the sum of the width of the items.</p>\n<p>Defaults to: <code>auto</code></p></div></div></div><div id='property-methods' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-property-methods' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-property-methods' class='name expandable'>methods</a> : Object<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>\n</div><div class='long'>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-ChangeToolbar' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-ChangeToolbar' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-ChangeToolbar' class='name expandable'>ChangeToolbar</a>( <span class='pre'>toolbar</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Changes the current list of toolbar items with a new one and render it. ...</div><div class='long'><p>Changes the current list of toolbar items with a new one and render it.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>toolbar</span> : gxuiToolbar<div class='sub-desc'><p>gxuiToolbar configuration object containing the list of new toolbar items to render</p>\n\n</div></li></ul></div></div></div><div id='method-DisableItem' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-DisableItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-DisableItem' class='name expandable'>DisableItem</a>( <span class='pre'>itemId</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Disable a toolbar item by id ...</div><div class='long'><p>Disable a toolbar item by id</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>itemId</span> : String<div class='sub-desc'><p>Toolbar item id</p>\n\n</div></li></ul></div></div></div><div id='method-EnableItem' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-EnableItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-EnableItem' class='name expandable'>EnableItem</a>( <span class='pre'>itemId</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Enable a toolbar item by id ...</div><div class='long'><p>Enable a toolbar item by id</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>itemId</span> : String<div class='sub-desc'><p>Toolbar item id</p>\n\n</div></li></ul></div></div></div><div id='method-GetData' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-GetData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-GetData' class='name expandable'>GetData</a>( <span class='pre'>data</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-GetToolbar' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-GetToolbar' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-GetToolbar' class='name expandable'>GetToolbar</a>( <span class='pre'>add</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>add</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-HideItem' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-HideItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-HideItem' class='name expandable'>HideItem</a>( <span class='pre'>itemId</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Hide a toolbar item by id ...</div><div class='long'><p>Hide a toolbar item by id</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>itemId</span> : String<div class='sub-desc'><p>Toolbar item id</p>\n\n</div></li></ul></div></div></div><div id='method-SetData' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-SetData' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-SetData' class='name expandable'>SetData</a>( <span class='pre'>data</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-ShowItem' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-ShowItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-ShowItem' class='name expandable'>ShowItem</a>( <span class='pre'>itemId</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Shows a hidden toolbar item by id ...</div><div class='long'><p>Shows a hidden toolbar item by id</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>itemId</span> : String<div class='sub-desc'><p>Toolbar item id</p>\n\n</div></li></ul></div></div></div><div id='method-adjustWidth' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-adjustWidth' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-adjustWidth' class='name expandable'>adjustWidth</a>( <span class='pre'>toolbar</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>toolbar</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-buttonActionHandler' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-buttonActionHandler' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-buttonActionHandler' class='name expandable'>buttonActionHandler</a>( <span class='pre'>btn, e</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>btn</span> : Object<div class='sub-desc'></div></li><li><span class='pre'>e</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-buttonClickHandler' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-buttonClickHandler' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-buttonClickHandler' class='name expandable'>buttonClickHandler</a>( <span class='pre'>btn, e</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>btn</span> : Object<div class='sub-desc'></div></li><li><span class='pre'>e</span> : Object<div class='sub-desc'></div></li></ul><h3 class='pa'>Fires</h3><ul><li>beforebuttonpressed</li><li>buttonpressed</li></ul></div></div></div><div id='method-changeItemPropertyValue' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-changeItemPropertyValue' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-changeItemPropertyValue' class='name expandable'>changeItemPropertyValue</a>( <span class='pre'>itemId, propertyId, propertyValue</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>itemId</span> : Object<div class='sub-desc'></div></li><li><span class='pre'>propertyId</span> : Object<div class='sub-desc'></div></li><li><span class='pre'>propertyValue</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-createButtons' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-createButtons' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-createButtons' class='name expandable'>createButtons</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n</div></div></div><div id='method-createToolbar' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-createToolbar' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-createToolbar' class='name expandable'>createToolbar</a>( <span class='pre'>options</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>options</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-defineBtnsDropTarget' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-defineBtnsDropTarget' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-defineBtnsDropTarget' class='name expandable'>defineBtnsDropTarget</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n</div></div></div><div id='method-editActionHandler' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-editActionHandler' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-editActionHandler' class='name expandable'>editActionHandler</a>( <span class='pre'>field</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>field</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-findItem' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-findItem' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-findItem' class='name expandable'>findItem</a>( <span class='pre'>id, items</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>id</span> : Object<div class='sub-desc'></div></li><li><span class='pre'>items</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-getBtnCls' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-getBtnCls' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-getBtnCls' class='name expandable'>getBtnCls</a>( <span class='pre'>btn</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>btn</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-getConfig' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-getConfig' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-getConfig' class='name expandable'>getConfig</a>( <span class='pre'>button</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>button</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-getUnderlyingControl' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-getUnderlyingControl' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-getUnderlyingControl' class='name expandable'>getUnderlyingControl</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-getUniqueButtonId' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-getUniqueButtonId' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-getUniqueButtonId' class='name expandable'>getUniqueButtonId</a>( <span class='pre'>btnId</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>btnId</span> : Object<div class='sub-desc'></div></li></ul></div></div></div><div id='method-initialize' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-initialize' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-initialize' class='name expandable'>initialize</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n<h3 class='pa'>Fires</h3><ul><li>editfieldblur</li><li>editfieldkeypress</li></ul></div></div></div><div id='method-onRefresh' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-onRefresh' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-onRefresh' class='name expandable'>onRefresh</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-onRender' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-onRender' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-onRender' class='name expandable'>onRender</a>( <span class='pre'></span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'> ...</div><div class='long'>\n</div></div></div><div id='method-refreshButtons' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-method-refreshButtons' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-method-refreshButtons' class='name expandable'>refreshButtons</a>( <span class='pre'>buttons, renderedButtons</span> )<span class=\"signature\"><span class='private' >private</span></span></div><div class='description'><div class='short'>private ...</div><div class='long'><p>private</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>buttons</span> : Object<div class='sub-desc'></div></li><li><span class='pre'>renderedButtons</span> : Object<div class='sub-desc'></div></li></ul></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-event'>Events</h3><div class='subsection'><div id='event-ButtonPressed' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gxui.Toolbar'>gxui.Toolbar</span><br/><a href='source/ToolbarRender.html#gxui-Toolbar-event-ButtonPressed' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gxui.Toolbar-event-ButtonPressed' class='name expandable'>ButtonPressed</a>( <span class='pre'>eOpts</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Fires after a toolbar item has been pressed. ...</div><div class='long'><p>Fires after a toolbar item has been pressed. The only items that fire this event are Button and SplitButton.\nThe following properties are set when the event is fired:</p>\n\n<ul>\n<li><a href=\"#!/api/gxui.Toolbar-property-ButtonPressedId\" rel=\"gxui.Toolbar-property-ButtonPressedId\" class=\"docClass\">ButtonPressedId</a></li>\n</ul>\n\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>eOpts</span> : Object<div class='sub-desc'><p>The options object passed to Ext.util.Observable.addListener.</p>\n\n\n\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});